oauthenticator.mediawiki#
A JupyterHub authenticator class for use with MediaWiki as an identity provider.
- class oauthenticator.mediawiki.MWOAuthenticator(**kwargs: Any)#
- admin_groups c.MWOAuthenticator.admin_groups = Set()#
Allow members of selected groups to sign in and consider them as JupyterHub admins.
If this is set and a user isn’t part of one of these groups or listed in
admin_users, a user signing in will have their admin status revoked.Requires
manage_groupsto also beTrue.Added in version 17: Previously available only on
GenericOAuthenticator
- admin_users c.MWOAuthenticator.admin_users = Set()#
Set of users that will be granted admin rights on this JupyterHub.
Note
As of JupyterHub 2.0, full admin rights should not be required, and more precise permissions can be managed via roles.
Caution
Adding users to
admin_userscan only grant admin rights, removing a username from the admin_users set DOES NOT remove admin rights previously granted.For an authoritative, restricted set of admins, assign explicit membership of the
adminrole:c.JupyterHub.load_roles = [ { "name": "admin", "users": ["admin1", "..."], } ]
Admin users can take every possible action on behalf of all users, for example:
Use the admin panel to see list of users logged in
Add / remove users in some authenticators
Restart / halt the hub
Start / stop users’ single-user servers
Can access each individual users’ single-user server
Admin access should be treated the same way root access is.
Defaults to an empty set, in which case no user has admin access.
- allow_all c.MWOAuthenticator.allow_all = Bool(False)#
Allow all authenticated users to login.
Overrides all other
allowconfiguration.Added in version 16.0.
- allow_existing_users c.MWOAuthenticator.allow_existing_users = Bool(False)#
Allow existing users to login.
Enable this if you want to manage user access via the JupyterHub admin page (/hub/admin).
With this enabled, all users present in the JupyterHub database are allowed to login. This has the effect of any user who has _previously_ been allowed to login via any means will continue to be allowed until the user is deleted via the /hub/admin page or REST API.
Warning
Before enabling this you should review the existing users in the JupyterHub admin panel at
/hub/admin. You may find users existing there because they have previously been declared in config such asallowed_usersor allowed to sign in.Warning
When this is enabled and you wish to remove access for one or more users previously allowed, you must make sure that they are removed from the jupyterhub database. This can be tricky to do if you stop allowing a group of externally managed users for example.
With this enabled, JupyterHub admin users can visit
/hub/adminor use JupyterHub’s REST API to add and remove users to manage who can login.Added in version 16.0.
Changed in version 16.0: Before this config was available, the default behavior was to allow existing users if
allowed_userswas configured with one or more user.
- allowed_groups c.MWOAuthenticator.allowed_groups = Set()#
Allow members of selected JupyterHub groups to log in.
Requires
manage_groupsto also beTrue. Typically also requiresauth_state_groups_keyto be configured to populate the JupyterHub groups.This option is independent of other configuration such as
GitLabOAuthenticator.allowed_gitlab_groups, which do not populate the JupyterHub groups, and do not requiremanage_groupsto be True.Added in version 17: Previously available only on
GenericOAuthenticator
- allowed_scopes c.MWOAuthenticator.allowed_scopes = List()#
Allow users who have been granted all these scopes to log in.
We request all the scopes listed in the ‘scope’ config, but only a subset of these may be granted by the authorization server. This may happen if the user does not have permissions to access a requested scope, or has chosen to not give consent for a particular scope. If the scopes listed in this config are not granted, the user will not be allowed to log in.
The granted scopes will be part of the access token (fetched from self.token_url). See https://datatracker.ietf.org/doc/html/rfc6749#section-3.3 for more information.
See the OAuth documentation of your OAuth provider for various options.
- allowed_users c.MWOAuthenticator.allowed_users = Set()#
Set of usernames that should be allowed to login.
If unspecified, grants no access. You must set at least one other
allowconfiguration if any users are to have permission to access the Hub.Any usernames in
admin_userswill also be allowed to login.
- any_allow_config c.MWOAuthenticator.any_allow_config = Bool(False)#
Is there any allow config?
Used to show a warning if it looks like nobody can access the Hub, which can happen when upgrading to JupyterHub 5, now that
allow_alldefaults to False.Deployments can set this explicitly to True to suppress the “No allow config found” warning.
Will be True if any config tagged with
.tag(allow_config=True)or starts withallowis truthy.Added in version 5.0.
- auth_refresh_age c.MWOAuthenticator.auth_refresh_age = Int(300)#
The max age (in seconds) of authentication info before forcing a refresh of user auth info.
Authenticators that support it may re-load managed groups, refresh auth tokens, etc., or force a new login if auth info cannot be refreshed.
See
refresh_user()for what happens when user auth info is refreshed, which varies by authenticator. If an Authenticator does not implementrefresh_user, auth info will never be considered stale.Set
auth_refresh_age = 0to disable time-based calls torefresh_user. You can still userefresh_pre_spawnorrefresh_pre_stopifauth_refresh_ageis disabled.
- auth_state_groups_key c.MWOAuthenticator.auth_state_groups_key = Union()#
Determine groups this user belongs based on contents of auth_state.
Can be a string key name (use periods for nested keys), or a callable that accepts the auth state (as a dict) and returns the groups list. Callables may be async.
Requires
manage_groupsto also beTrue.Added in version 17.0: Previously available as
GenericOAuthenticator.claim_groups_key
- authorize_url c.MWOAuthenticator.authorize_url = Unicode('')#
The URL to where the user is to be redirected initially based on the OAuth2 protocol. The user will be redirected back with an authorization grant code after authenticating successfully with the identity provider.
For more context, see the Protocol Flow section in the OAuth2 standard document, specifically steps A-B.
- auto_login c.MWOAuthenticator.auto_login = Bool(False)#
Automatically begin the login process
rather than starting with a “Login with…” link at
/hub/loginTo work,
.login_url()must give a URL other than the default/hub/login, such as an oauth handler or another automatic login handler, registered with.get_handlers().Added in version 0.8.
- auto_login_oauth2_authorize c.MWOAuthenticator.auto_login_oauth2_authorize = Bool(False)#
Automatically begin login process for OAuth2 authorization requests
When another application is using JupyterHub as OAuth2 provider, it sends users to
/hub/api/oauth2/authorize. If the user isn’t logged in already, and auto_login is not set, the user will be dumped on the hub’s home page, without any context on what to do next.Setting this to true will automatically redirect users to login if they aren’t logged in only on the
/hub/api/oauth2/authorizeendpoint.Added in version 1.5.
- basic_auth c.MWOAuthenticator.basic_auth = Bool(False)#
Whether or to use HTTP Basic authentication instead of form based authentication in requests to
token_url.When using HTTP Basic authentication, a HTTP header is set with the
client_idandclient_secretencoded in it.When using form based authentication, the
client_idandclient_secretis put in the HTTP POST request’s body.Changed in version 16.0.0: This configuration now toggles between HTTP Basic authentication and form based authentication when working against the
token_url.Previously when this was configured True, both would be used contrary to a recommendation in OAuth 2.0 documentation.
Changed in version 16.0.2: The default value for this configuration for GenericOAuthenticator changed from True to False.
- blocked_users c.MWOAuthenticator.blocked_users = Set()#
Set of usernames that are not allowed to log in.
Use this with supported authenticators to restrict which users can not log in. This is an additional block list that further restricts users, beyond whatever restrictions the authenticator has in place.
If empty, does not perform any additional restriction.
Changed in version 5.2: Users blocked via
blocked_usersthat may have logged in in the past have all permissions and group membership revoked and all servers stopped at JupyterHub startup. Previously, User permissions (e.g. API tokens) and servers were unaffected and required additional administrator operations to block after a user is added toblocked_users.Changed in version 1.2:
Authenticator.blacklistrenamed toblocked_users
- build_access_tokens_request_params(handler, data=None)#
We’re overriding this method because mediawiki needs a Handshaker object to send the tokes request. So, we’re building the params directly in the
get_token_info.
- build_auth_state_dict(token_info, user_info)#
Builds the
auth_statedict that will be returned by a successfulauthenticatemethod call. May be async (requires oauthenticator >= 17.0).- Parameters:
token_info – the dictionary returned by the token request (exchanging the OAuth code for an Access Token)
user_info – the dictionary returned by the userdata request
- Returns:
- a dictionary of auth state that should be persisted with the following keys:
”access_token”: the access_token
”refresh_token”: the refresh_token, if available
”id_token”: the id_token, if available
”scope”: the scopes, if available
”token_response”: the full token_info response
self.user_auth_state_key: the full user_info response
- Return type:
auth_state
Called by
authenticate()andrefresh_user().Changed in version 17.0: This method may be async.
- callback_handler#
alias of
MWCallbackHandler
- client_id c.MWOAuthenticator.client_id = Unicode('')#
The client id of the OAuth2 application registered with the identity provider.
- client_secret c.MWOAuthenticator.client_secret = Unicode('')#
The client secret of the OAuth2 application registered with the identity provider.
- custom_403_message c.MWOAuthenticator.custom_403_message = Unicode('Sorry, you are not currently authorized to use this hub. Please contact the hub administrator.')#
The message to be shown when user was not allowed
- delete_invalid_users c.MWOAuthenticator.delete_invalid_users = Bool(False)#
Delete any users from the database that do not pass validation
When JupyterHub starts,
.add_userwill be called on each user in the database to verify that all users are still valid.If
delete_invalid_usersis True, any users that do not pass validation will be deleted from the database. Use this if users might be deleted from an external system, such as local user accounts.If False (default), invalid users remain in the Hub’s database and a warning will be issued. This is the default to avoid data loss due to config changes.
- enable_auth_state c.MWOAuthenticator.enable_auth_state = Bool(False)#
Enable persisting auth_state (if available).
auth_state will be encrypted and stored in the Hub’s database. This can include things like authentication tokens, etc. to be passed to Spawners as environment variables.
Encrypting auth_state requires the cryptography package.
Additionally, the JUPYTERHUB_CRYPT_KEY environment variable must contain one (or more, separated by ;) 32B encryption keys. These can be either base64 or hex-encoded.
If encryption is unavailable, auth_state cannot be persisted.
New in JupyterHub 0.8
- enable_pkce c.MWOAuthenticator.enable_pkce = Bool(True)#
Enable Proof Key for Code Exchange (PKCE) for the OAuth2 authorization code flow. For more information, see RFC 7636.
PKCE can be used even if the authorization server does not support it. According to section 3.1 of RFC 6749:
The authorization server MUST ignore unrecognized request parameters.
Additionally, section 5 of RFC 7636 states:
As the OAuth 2.0 [RFC6749] server responses are unchanged by this specification, client implementations of this specification do not need to know if the server has implemented this specification or not and SHOULD send the additional parameters as defined in Section 4 to all servers.
Note that S256 is the only code challenge method supported. As per section 4.2 of RFC 6749:
If the client is capable of using “S256”, it MUST use “S256”, as “S256” is Mandatory To Implement (MTI) on the server.
- executor_threads c.MWOAuthenticator.executor_threads = Int(12)#
Number of executor threads.
MediaWiki OAuth requests happen in this thread, so it is mostly waiting for network replies.
- extra_authorize_params c.MWOAuthenticator.extra_authorize_params = Dict()#
Extra GET params to send along with the initial OAuth request to the OAuth provider.
- async get_token_info(handler, params)#
Makes a “POST” request to
self.token_url, with the parameters received as argument.- Returns:
the JSON response to the
token_urlthe request as described in https://www.rfc-editor.org/rfc/rfc6749#section-5.1
Called by
authenticate()andrefresh_user().
- http_request_kwargs c.MWOAuthenticator.http_request_kwargs = Dict()#
Extra default kwargs passed to all HTTPRequests.
# Example: send requests through a proxy c.OAuthenticator.http_request_kwargs = { "proxy_host": "proxy.example.com", "proxy_port": 8080, } # Example: validate against certain root certificates c.OAuthenticator.http_request_kwargs = { "ca_certs": "/path/to/a.crt", }
See
tornado.httpclient.HTTPRequestfor all kwargs options you can pass. Note that the HTTP client making these requests istornado.httpclient.AsyncHTTPClient.
- login_handler#
alias of
MWLoginHandler
- login_service c.MWOAuthenticator.login_service = Unicode('OAuth 2.0')#
Name of the login service or identity provider that this authenticator is using to authenticate users.
This config influences the text on a button shown to unauthenticated users before they click it to login, assuming
auto_loginisn’t configured True.The login button’s text will be “Login with <login_service>”.
- logout_redirect_url c.MWOAuthenticator.logout_redirect_url = Unicode('')#
When configured, users are not presented with the JupyterHub logout page, but instead redirected to this destination.
- manage_groups c.MWOAuthenticator.manage_groups = Bool(False)#
Let authenticator manage user groups
If True, Authenticator.authenticate and/or .refresh_user may return a list of group names in the ‘groups’ field, which will be assigned to the user.
All group-assignment APIs are disabled if this is True.
- manage_roles c.MWOAuthenticator.manage_roles = Bool(False)#
Let authenticator manage roles
If True, Authenticator.authenticate and/or .refresh_user may return a list of roles in the ‘roles’ field, which will be added to the database.
When enabled, all role management will be handled by the authenticator; in particular, assignment of roles via
JupyterHub.load_rolestraitlet will not be possible.Added in version 5.0.
- modify_auth_state_hook c.MWOAuthenticator.modify_auth_state_hook = Callable(None)#
Callable to modify
auth_stateWill be called with the Authenticator instance and the existing auth_state dictionary and must return the new auth_state dictionary:
auth_state = [await] modify_auth_state_hook(authenticator, auth_state)
This hook is called before populating group membership, so can be used to make additional requests to populate additional fields which may then be consumed by
auth_state_groups_keyto populate groups.This hook may be async.
- mw_index_url c.MWOAuthenticator.mw_index_url = Unicode('https://meta.wikimedia.org/w/index.php')#
Full path to index.php of the MW instance to use to log in
- normalize_username(username)#
Override normalize_username to avoid lowercasing usernames.
- oauth_callback_url c.MWOAuthenticator.oauth_callback_url = Unicode('')#
Callback URL to use.
When registering an OAuth2 application with an identity provider, this is typically called the redirect url.
Should very likely be set to
https://[your-domain]/hub/oauth_callback.
- otp_prompt c.MWOAuthenticator.otp_prompt = Any('OTP:')#
The prompt string for the extra OTP (One Time Password) field.
Added in version 5.0.
- post_auth_hook c.MWOAuthenticator.post_auth_hook = Any(None)#
An optional hook function that you can implement to do some bootstrapping work during authentication. For example, loading user account details from an external system.
This function is called after the user has passed all authentication checks and is ready to successfully authenticate. This function must return the auth_model dict reguardless of changes to it. The hook is called with 3 positional arguments:
(authenticator, handler, auth_model).This may be a coroutine.
Example:
import os import pwd def my_hook(authenticator, handler, auth_model): user_data = pwd.getpwnam(auth_model['name']) spawn_data = { 'pw_data': user_data 'gid_list': os.getgrouplist(auth_model['name'], user_data.pw_gid) } if auth_model['auth_state'] is None: auth_model['auth_state'] = {} auth_model['auth_state']['spawn_data'] = spawn_data return auth_model c.Authenticator.post_auth_hook = my_hook
- refresh_pre_spawn c.MWOAuthenticator.refresh_pre_spawn = Bool(False)#
Force refresh of auth prior to spawn.
This forces
refresh_user()to be called prior to launching a server, to ensure that auth state is up-to-date.This can be important when e.g. auth tokens that may have expired are passed to the spawner via environment variables from auth_state.
If refresh_user cannot refresh the user auth data, launch will fail until the user logs in again.
- refresh_pre_stop c.MWOAuthenticator.refresh_pre_stop = Bool(False)#
Force refresh of auth prior to stop.
This forces
refresh_user()to be called prior to stopping a server, to ensure that auth state is up-to-date.This can be important when e.g. auth tokens stored in auth_state may have expired, but are a required part of the Spawner’s shutdown steps.
If refresh_user cannot refresh the user auth data, stop will fail until the user logs in again. If an admin initiates the stop, it will proceed regardless.
Added in version 5.4.
- refresh_user_hook c.MWOAuthenticator.refresh_user_hook = Callable(None)#
Hook for refreshing user auth info.
If given, allows overriding the
refresh_userbehavior. Will be called as:refreshed = await refresh_user_hook(authenticator, user, auth_state)
refresh_user_hook_may_ be async.where
refreshedcan be:True (no change)
False (require new login)
auth_model (dict - the new auth model, if anything should be changeed)
None (proceed with default refresh_user behavior - allows overriding refresh_user behavior for _some_ users)
Added in version 17.3.
- request_otp c.MWOAuthenticator.request_otp = Bool(False)#
Prompt for OTP (One Time Password) in the login form.
Added in version 5.0.
- reset_managed_roles_on_startup c.MWOAuthenticator.reset_managed_roles_on_startup = Bool(False)#
Reset managed roles to result of
load_managed_roles()on startup.- If True:
stale managed roles will be removed,
stale assignments to managed roles will be removed.
Any role not present in
load_managed_roles()will be considered ‘stale’.The ‘stale’ status for role assignments is also determined from
load_managed_roles()result:user role assignments status will depend on whether the
userskey is defined or not:if a list is defined under the
userskey and the user is not listed, then the user role assignment will be considered ‘stale’,if the
userskey is not provided, the user role assignment will be preserved;
service and group role assignments will be considered ‘stale’:
if not included in the
servicesandgroupslist,if the
servicesandgroupskeys are not provided.
Added in version 5.0.
- scope c.MWOAuthenticator.scope = List()#
The OAuth scopes to request.
See the OAuth documentation of your OAuth provider for options.
- token_params c.MWOAuthenticator.token_params = Dict()#
Extra parameters for first POST request exchanging the OAuth code for an Access Token
- async token_to_user(token_info)#
Determines who the logged-in user by sending a “GET” request to
userdata_urlusing theaccess_token.If
userdata_from_id_tokenis set then extracts the corresponding info from anid_tokeninstead.- Parameters:
token_info – the dictionary returned by the token request (exchanging the OAuth code for an Access Token)
- Returns:
the JSON response to the
userdata_urlrequest.
Called by
authenticate()andrefresh_user().
- token_url c.MWOAuthenticator.token_url = Unicode('')#
The URL to where this authenticator makes a request to acquire an access token based on the authorization code received by the user returning from the
authorize_url.For more context, see the Protocol Flow section in the OAuth2 standard document, specifically steps C-D.
- userdata_from_id_token c.MWOAuthenticator.userdata_from_id_token = Bool(False)#
Extract user details from an id token received via a request to
token_url, rather than making a follow-up request to the userinfo endpointuserdata_url.Should only be used if
token_urluses HTTPS, to ensure token authenticity.For more context, see Authentication using the Authorization Code Flow in the OIDC Core standard document.
- userdata_params c.MWOAuthenticator.userdata_params = Dict()#
Userdata params to get user data login information.
- userdata_token_method c.MWOAuthenticator.userdata_token_method = Unicode('header')#
Method for sending access token in userdata request.
Supported methods: header, url.
- userdata_url c.MWOAuthenticator.userdata_url = Unicode('')#
The URL to where this authenticator makes a request to acquire user details with an access token received via a request to the
token_url.For more context, see the Protocol Flow section in the OAuth2 standard document, specifically steps E-F.
Incompatible with
userdata_from_id_token.
- username_claim c.MWOAuthenticator.username_claim = Union()#
When
userdata_urlreturns a json response, the username will be taken from this key.Can be a string key name or a callable that accepts the returned userdata json (as a dict) and returns the username. The callable is useful e.g. for extracting the username from a nested object in the response or doing other post processing.
What keys are available will depend on the scopes requested and the authenticator used.
- username_map c.MWOAuthenticator.username_map = Dict()#
Dictionary mapping authenticator usernames to JupyterHub users.
Primarily used to normalize OAuth user names to local users.
- username_pattern c.MWOAuthenticator.username_pattern = Unicode('')#
Regular expression pattern that all valid usernames must match.
If a username does not match the pattern specified here, authentication will not be attempted.
If not set, allow any username.
- validate_server_cert c.MWOAuthenticator.validate_server_cert = Bool(False)#
Determines if certificates are validated.
Only set this to False if you feel confident it will not be a security concern.
- whitelist c.MWOAuthenticator.whitelist = Set()#
Deprecated, use
Authenticator.allowed_users